package SAC;
use strict;
use FindBin qw($RealDir);
use lib $RealDir;
use FORKER;

our (@ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS, $VERSION);

use Exporter;
$VERSION = 2007.323;
@ISA = qw(Exporter);

@EXPORT = qw(sacread chnhdr sacmacro saclh parselh runsac runsac2); # symbols to autoexport (:DEFAULT tag)
@EXPORT_OK = qw(); # symbols to export on request
%EXPORT_TAGS = (
	sac => [qw(sacread chnhdr sacmacro saclh parselh runsac runsac2)],
	direct => [qw(rsac wsac)],
);

# BEGIN CODE
###################################################################

sub rsac {
	
}

sub wsac {
	
}

# MAKES A READ STATEMENT FOR A SAC MACRO
sub sacread {
	my (@files)=@_;
	my $read='';
	foreach (@files) {$read.="r more $_\n";}
	return $read;
}

# MAKE A CHANGE HEADER MACRO
sub chnhdr {
	my ($read,$field,$value,$write)=@_;
	return sacmacro($read,"chnhdr $field $value",$write);
}

# MAKES A SIMPLE MACRO
sub sacmacro {
	my ($read,$main,$write)=@_;
	(my $sac=<<"	_END_")=~s/^\s+//gm;
		production on
		$read
		$main
		$write
		quit
	_END_

	return $sac;
}

# TAKES 2 ARRAY REFERENCES - ONE OF HEADER NAMES AND ONE OF FILENAMES
sub saclh {return `saclst2 @{$_[0]} - @{$_[1]}`;}

# TAKES OUTPUT FROM SACLH AND PARSES INTO A 2-D ARRAY
# ACCESS USING $ARRAY[ROW][COLUMN]
sub parselh {
	my @array;
	foreach (@_) {push @array,[split(' ',$_)];}
	return @array;
}

# TAKES A SAC MACRO AS INPUT - EITHER AS A HERE DOCUMENT OR AS AN ARRAY OF COMMANDS
sub runsac {
	# RUNNING SAC MACRO
	my $ofile="sac.in.$$";
	open(OUT,">$ofile") or print "COULD NOT CREATE SAC MACRO FILE: $ofile!\n" and mexit(3040); 
	print OUT join("\n",@_),"\n"; close (OUT); print `sac $ofile`;
	
	# CHECK FOR FAILURE
	my $exitcode = $? >> 8;  # exit code
	my $exitsign = $? & 127; # signal that caused exit
	if ($exitcode or $exitsign) {print "SAC MACRO FAILED!\n" and mexit(3041);}
	unlink($ofile) or print "COULD NOT DELETE MACRO $ofile!\n" and mexit(3042);
}

# TAKES A SAC MACRO AS INPUT - EITHER AS A HERE DOCUMENT OR AS AN ARRAY OF COMMANDS
# THIS VERSION RETURNS THE EXIT STATUS AND DOES NOT DELETE THE MACRO FILE
sub runsac2 {
	# RUNNING SAC MACRO
	my $ofile="sac.in.$$";
	open(OUT,">$ofile") or print "COULD NOT CREATE SAC MACRO FILE: $ofile!\n" and mexit(3040); 
	print OUT join("\n",@_),"\n"; close (OUT); `sac $ofile`;
	
	# CHECK FOR FAILURE
	my $exitcode = $? >> 8;  # exit code
	my $exitsign = $? & 127; # signal that caused exit
	return ($exitcode or $exitsign);
}
###################################################################
1;

