#!/usr/bin/perl -w
use strict;
use FindBin qw($RealDir);
use lib $RealDir;
use MISC qw(get_dir_dirs);

# FIXES DATABASE INCOMPLETENESS

# input arguments
print "Please include input and output data directories as well as\nthe event and log directories and finally the network code\nand number of threads for this job as arguments!\n" and exit(1) if ($#ARGV!=5);
my ($iddir,$oddir,$evdir,$logdir,$knetwk,$nproc)=@ARGV;

# CHECK INPUT DIRECTORIES EXISTS
if (! -e $iddir) {print "DATA DIRECTORY $iddir NOT FOUND!\n" and exit(2);}
if (! -e $evdir) {print "EVENT DIRECTORY $evdir NOT FOUND!\n" and exit(3);}

# CHECK KNETWK AND NPROC
#  - SKIPPING THIS FOR NOW (DONT CARE THAT MUCH)

# GET SUBDIRECTORIES (DATES)
my @subdir=get_dir_dirs($iddir);

# RUNNING ON EACH SUBDIRECTORY
`mkdir -p $oddir $logdir`;
`fixdb2sac.pl $iddir/$_ $oddir/$_ $evdir/$_.event $knetwk $nproc &> $logdir/$_.fixdb2sac.log` foreach @subdir;

