#!/usr/bin/perl -w
use strict;
use FindBin qw($RealDir);
use lib $RealDir;
use MISC qw(get_dir_dirs);

# FIXES GAPS AND OVERLAPS

# input arguments
print "Please include input and output data directories as well as\nthe log directory and finally the max time length in seconds!\n" and exit(1) if ($#ARGV!=3);
my ($iddir,$oddir,$logdir,$maxlen)=@ARGV;

# CHECK INPUT DIRECTORIES EXISTS
if (! -e $iddir) {print "DATA DIRECTORY $iddir NOT FOUND!\n" and exit(2);}

# CHECK OTHER INPUTS
#  - SKIPPING THIS FOR NOW (DONT CARE THAT MUCH)

# GET SUBDIRECTORIES (DATES)
my @subdir=get_dir_dirs($iddir);

# BUILD WEED SCRIPT
open(WEED,">$logdir/weed.in.$$"); print WEED "1\n5\ne b\n0 $maxlen\n\n6\n"; close(WEED);

# RUNNING ON EACH SUBDIRECTORY
`mkdir -p $oddir $logdir`;
`weed.pl $iddir/$_ $oddir/$_ < $logdir/weed.in.$$ > $logdir/$_.weed.log` foreach @subdir;
